/*  /home/digre/b/anders/cvs/rwhod/rwu.c,  Thu Feb 21 21:17:02 1991 edit by: anders@mago.ifi.uio.no  */

/*
 * $Id: rwud.c,v 1.13 1996/07/22 15:59:32 anders Exp $
 *
 * $Log: rwud.c,v $
 * Revision 1.13  1996/07/22  15:59:32  anders
 * Portet til solaris og linux
 *
 * Revision 1.10  1993/11/22  10:40:38  anders
 * sgi port
 *
 * Revision 1.9  1991/05/27  09:18:59  anders
 * Tatt vekk reopen av socket til loghost
 *
 * Revision 1.8  91/03/14  18:45:01  anders
 * ----------------------------------------------------------------------
 * fixed malloc bug in rwud
 * changed from strcpy to strncpy in rwurd
 * 
 * Revision 1.7  91/03/05  18:54:39  anders
 * ----------------------------------------------------------------------
 * Lagt inn reopen av socketen hver n'te time for } supporte renaming
 * av rwhoserver maskinen.
 * 
 * Ymse sm}rydding.
 * 
 * Revision 1.6  91/03/05  05:24:32  anders
 * ----------------------------------------------------------------------
 * Create daemon version with minimal overhead on network and log-server
 * 
 * Revision 1.5  91/03/04  20:31:02  anders
 * ----------------------------------------------------------------------
 * Lagt inn syslog
 * 
 * Revision 1.4  91/03/01  17:28:08  anders
 * ----------------------------------------------------------------------
 * added a daemon fork.
 * 
 * Revision 1.3  91/02/26  01:36:07  anders
 * ----------------------------------------------------------------------
 * portet til sun
 * 
 * Revision 1.2  91/02/22  20:11:04  anders
 * ----------------------------------------------------------------------
 * Removed some debugging code
 * 
 * Revision 1.1  91/02/21  22:30:00  anders
 * Initial revision
 * 
 *
 */

/*
 * Remote who & uptime daemon
 */

#ifdef __sgi
# define KERNEL "/unix"
#elif defined(__svr4__)
# define KERNEL "ksyms"
#else
# define KERNEL "/vmunix"
#endif

#define RWHOHOST "rwhoserver"
#define RWHOPORT 550

#define	WHODVERSION	1
#define	WHODTYPE_STATUS	1		/* host status */
#include <sys/param.h>
#include <sys/types.h>
#include <stdio.h>
#include <nlist.h>
#include <signal.h>
#include <utmp.h>
#ifndef NeXT
#include <unistd.h>
#endif
#include <sys/stat.h>
#include <sys/file.h>
#include <syslog.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#ifndef OLDULTRIX
#include <stdlib.h>
#ifdef ultrix
#include <sys/fixpoint.h>
#endif
#else
char *malloc(), *realloc();
#endif
#ifdef __svr4__
#include <sys/fcntl.h>
#endif

#include "rwud.h"
#ifndef __hpux
long lseek();
#endif
#ifdef DEBUG
#define WAITTIME 5
#else
#define WAITTIME (60)
#endif

#ifdef __linux__
FILE *f;
int uptime;
float load1;
float load5;
float load15;
#else
int kmem;
#endif
int utmp;

struct whod wd;

#ifndef __linux__
struct  nlist nl[] = {
#ifdef __sgi
# define NL_AVENRUN      0
        { "avenrun" },
# define NL_BOOTTIME     1
        { "boottime" },
        0
#elif defined(__svr4__)
# define NL_AVENRUN      0
        { "avenrun" },
# else
#  define NL_AVENRUN      0
        { "_avenrun" },
#  define NL_BOOTTIME     1
        { "_boottime" },
        0
#endif
};
#endif /* !linux */

#ifndef UTMP_FILE
#define UTMP_FILE "/etc/utmp"
#endif

int soc;				/* Socket to use */
struct sockaddr_in si;			/* Remote host */

void fatal();
void warn();

void
initialize()
{
#ifdef LOG_DAEMON
	openlog ("rwud", LOG_PID | LOG_CONS, LOG_DAEMON);
#else
	openlog ("rwud", LOG_PID);
#endif
#ifndef DEBUG
	close (0);
	close (1);
	close (2);
#endif
	srand(time(0L) ^ getpid());
#ifndef DEBUG
	sleep (rand() % 120);	/* Wait up to 2 min before starting */
#endif
	syslog (LOG_INFO, "starting");
	if (chdir ("/dev") == -1)
		fatal ("chdir");
	if (gethostname (wd.wd_hostname, 32) == -1)
		fatal ("gethostbyname");
#ifndef __linux__
	if (nlist (KERNEL, nl) != 0)
		fatal ("nlist");
	if ((kmem = open ("kmem", O_RDONLY)) == -1)
		fatal("open /dev/kmem");
#endif
	if ((utmp = open(UTMP_FILE, O_RDONLY)) == -1)
		fatal("open UTMP_FILE");
	wd.wd_vers = WHODVERSION;
	wd.wd_type = WHODTYPE_STATUS;
#if !defined(__svr4__) && !defined(__linux__)
	if (lseek(kmem, (long)nl[NL_BOOTTIME].n_value, L_SET) == -1)
		fatal("lseek kmem");
        (void) read(kmem, (char *)&wd.wd_boottime, sizeof (wd.wd_boottime));
#elif defined (__linux__)
	if ((f = fopen ("/proc/uptime", "r")) == NULL)
		fatal ("open /proc/uptime");
	fscanf (f, "%d", &uptime);
	fclose (f);
	wd.wd_boottime = time(0) - uptime;
#endif
#ifdef DEBUG
	printf ("boot: %d\n", wd.wd_boottime);
#endif
        wd.wd_boottime = htonl(wd.wd_boottime);
	while ( (soc = udpconn (RWHOHOST, RWHOPORT)) == 0) {
		warn ("udpconn1");
		sleep(60);		/* Don't know if this could ever fail, but... */
	}
}

int
udpconn (hstnam, port)
	char *hstnam;
	int port;
{
	register struct hostent *host = 0;
	int             net;

	si.sin_addr.s_addr = inet_addr (hstnam);
	if (si.sin_addr.s_addr != -1) {
		si.sin_family = AF_INET;
	} else {
		if ( (host = gethostbyname (hstnam)) != NULL) {
			si.sin_family = host->h_addrtype;
			bcopy (host->h_addr, (caddr_t) & si.sin_addr,
			       host->h_length);
		} else
			fatal ("gethostbyname");
	}
	si.sin_port = htons ((short) port);

	if ( (net = socket (AF_INET, SOCK_DGRAM, 0)) < 0) {
		warn ("udpconn: socket");
		return 0;
	}
	return net;
}

void
collect()
{
	static struct stat stb;
	static int utmptime = 0;
	static char *utmpbuf = 0;
	char *np;
	int i;
	int n;
	int data;
	long now = time(0);
#ifdef sun
        long avenrun[3];
#elif defined(ultrix) && defined(mips)
        fix avenrun[3];
#elif defined(__linux__)
	float avenrun[3];
#else
        long avenrun[3];
#endif
	struct utmp *up;
	struct whoent *wp;

	if (utmpbuf == 0) 
		utmpbuf = malloc (sizeof (struct utmp) * 20);
	wd.wd_recvtime = htonl(now);
	wd.wd_sendtime = wd.wd_recvtime;
#ifdef __linux__
	if ((f = fopen ("/proc/loadavg", "r")) == NULL)
		fatal ("open /proc/loadavg");
	fscanf (f, "%f %f %f", &avenrun[0], &avenrun[1], &avenrun[2]);
	fclose (f);
#else
        if (lseek(kmem, (long)nl[NL_AVENRUN].n_value, L_SET) == -1)
		fatal ("lseek kmem avenrun");
	if (read(kmem, (char *)avenrun, sizeof (avenrun)) == -1)
		fatal ("read kmem avenrun");
#endif /* !linux */
        for (i = 0; i < 3; i++)
                wd.wd_loadav[i] = 
#ifdef sun
		htonl((u_long)((double)avenrun[i] * 100/FSCALE));
#elif defined(ultrix) && defined(mips)
		htonl((u_long)(FIX_TO_DBL(avenrun[i]) * 100));
#elif defined(__linux__)
		htonl((u_long)(avenrun[i] * 100 + 0.5));
#else
		htonl((u_long)(avenrun[i] * 100 / 1024));
#endif
#ifdef DEBUG
	printf ("%x %x %x\n", wd.wd_loadav[0], wd.wd_loadav[1], wd.wd_loadav[2]);
#endif
        (void) fstat(utmp, &stb);
	utmptime = stb.st_mtime;
	utmpbuf = realloc (utmpbuf, stb.st_size + 1);
	if (lseek(utmp, 0, SEEK_SET) == -1)
		fatal("lseek utmp");
	if ((n = read(utmp, utmpbuf, stb.st_size + 1)) == -1)
		fatal("read utmp");
	np = utmpbuf + stb.st_size;
	for (up = (struct utmp *) utmpbuf, wp = wd.wd_we; (char *)up < np; up++) {
		if (
#ifdef USER_PROCESS
		    up->ut_type == USER_PROCESS
#else
		    up->ut_name[0]
#endif
		    ) {
			strcpy (wp->we_utmp.out_name, up->ut_name);
			strcpy (wp->we_utmp.out_line, up->ut_line);
			wp->we_utmp.out_time = htonl(up->ut_time);
			if (stat(wp->we_utmp.out_line, &stb) >= 0)
				wp->we_idle = htonl (now - stb.st_atime);
#ifdef DEBUG
			printf ("User: %s, Line %s, Time %d\n", wp->we_utmp.out_name, wp->we_utmp.out_line, wp->we_idle);
#endif
			wp++;
		}
#ifdef BOOT_TIME
		else if (up->ut_type == BOOT_TIME) {
#ifdef DEBUG
			printf ("Boot record: %s %d\n", up->ut_name, up->ut_time);
#endif
			wd.wd_boottime = up->ut_time;
		}
#endif
	}
	if (sendto (soc, (char *)&wd, (int) ((char *)wp - (char *)&wd),
		    0, &si, sizeof (si)) == -1)
		warn ("sendto");
}


main()
{
	int count = 0;
#ifndef DEBUG
	if(fork() == 0) {
#endif
		initialize();
		for(;;) {
			collect();
			sleep (WAITTIME);
		}
#ifndef DEBUG
	}
#endif
	return 0;
}


void
fatal(str)
	char *str;
{
	syslog (LOG_ERR, "%s: %m", str);
	(void) exit (1);
}

void
warn(str)
	char *str;
{
	syslog (LOG_ERR, "%s: %m", str);
}
