/*
 *
 * the Remote Who & Uptime Receiver Daemon
 *  - This program receives data from various rwud's
 *
 * $Id: rwurd.c,v 1.7 1996/06/18 21:38:01 kjetilho Exp $
 *
 * $Log: rwurd.c,v $
 * Revision 1.7  1996/06/18  21:38:01  kjetilho
 * Solaris-fiksing.
 *
 * Revision 1.6  1993/11/22 10:40:40  anders
 * sgi port
 *
 * Revision 1.5  1991/05/27  09:22:01  anders
 * added missing ;
 *
 * Revision 1.4  91/03/14  18:45:06  anders
 * ----------------------------------------------------------------------
 * fixed malloc bug in rwud
 * changed from strcpy to strncpy in rwurd
 * 
 * Revision 1.3  91/03/07  23:35:18  anders
 * ----------------------------------------------------------------------
 * Kommentert ut close(0..2) intil jeg finner ut hva som krever at en av 
 * disse filene skal v{re }pne.
 * 
 * Revision 1.2  91/03/05  18:54:43  anders
 * ----------------------------------------------------------------------
 * Lagt inn reopen av socketen hver n'te time for } supporte renaming
 * av rwhoserver maskinen.
 * 
 * Ymse sm}rydding.
 * 
 * Revision 1.1  91/03/05  05:24:25  anders
 * Initial revision
 * 
 *
 */

#define RWHOPORT 550

#define BUFFLEN 10000

#include <sys/types.h>
#include <sys/param.h>
#include <syslog.h>
#include <netinet/in.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <sys/socket.h>
#include <sys/file.h>
#include <fcntl.h>			/* for O_RDONLY Solaris 2.5 */


#include "rwud.h"

void initialize();
void receive();
void fatal();
void warn();

int net;
int portnum = RWHOPORT;
struct sockaddr_in sa;

main()
{
#ifndef DEBUG
	if (fork() == 0) {
#endif
		initialize();
		receive();
#ifndef DEBUG
	}
#endif
}

void
initialize()
{
	struct hostent *hp;
	char myname[MAXHOSTNAMELEN+1];

#ifdef LOG_DAEMON
	openlog ("rwurd", LOG_PID | LOG_CONS, LOG_DAEMON);
#else
	openlog ("rwurd", LOG_PID);
#endif
#if 0
#ifndef DEBUG
	close (0);
	close (1);
	close (2);
#endif
#endif
	if (chdir ("/usr/spool/rwho") == -1)
		fatal ("chdir");
	bzero(&sa,sizeof(struct sockaddr_in));
	gethostname(myname,MAXHOSTNAMELEN);
	if ( (hp = gethostbyname(myname)) == NULL)
		fatal("gethostbyname");
	sa.sin_family= hp->h_addrtype;              /* this is our host address */
	sa.sin_port= htons(portnum);                /* this is our port number */
	if ((net = socket (AF_INET, SOCK_DGRAM, 0)) < 0)
		fatal ("socket");
	if (bind (net, (struct sockaddr *) &sa, sizeof sa) < 0)
		fatal("bind");
}

void
receive()
{
	char file[1006];		/* String to build filename in */
	char *hnam = file+5;		/* pointer into filename  */
	char buff[BUFFLEN+1];		/* Receive buffer */
	int len;			/* Length of data received */
	int data;			/* fd for datafile */
	int fromlen;			/* dummy arg to recvfrom */

	(void) strcpy (file, "whod.");

	for(;;) {
		fromlen = 0;
		if (( len = recvfrom (net, buff, BUFFLEN, 0, NULL, &fromlen)) == -1)
			warn ("recvfrom");
#ifdef DEBUG
		printf ("Received %d bytes from %s\n", len,
			((struct whod *)buff)->wd_hostname);
#endif
		(void) strncpy (hnam, ((struct whod *)buff)->wd_hostname, 1000); /* Append to filename */
		/* I don't bother with the sanity checks in the original rwhod, if */
		/* anyone wants to put junk in my filesystem, then let them do that. */
		if ((data = open (file, O_CREAT | O_WRONLY | O_TRUNC, 0666)) == -1)
			fatal ("open file");
		if (write (data, buff, len) == -1)
			fatal ("write file");
		if (close (data) == -1)
			fatal ("close file");
	}
}

void
fatal(str)
	char *str;
{
	syslog (LOG_ERR, "%s: %m", str);
	(void) exit (1);
}

void
warn(str)
	char *str;
{
	syslog (LOG_ERR, "%s: %m, exiting", str);
}
